src/challenge/__init__.py
from flask import Flask
from flask_uploads import configure_uploads
from flask_uploads import patch_request_class
from dramatiq.results.backends import RedisBackend
from dramatiq.results import Results
from dramatiq import set_broker
from .extensions import dramatiq
from .extensions import video_storage
from .extensions import frame_storage
from .extensions import mongo
from .tasks import * # without this import 'actors' will be not attached to the dramatiq object



def create_app():
    app = Flask("challenge")
    app.config.from_envvar("FLASK_SETTINGS")
    register_extensions(app)
    register_blueprints(app)
    return app


def register_extensions(app):
    configure_uploads(app, (video_storage, frame_storage))
    patch_request_class(app, 3 * 1024 * 1024)
    dramatiq.middleware.append(Results(backend=RedisBackend()))
    dramatiq.init_app(app)
    set_broker(dramatiq.broker)
    mongo.init_app(app)


def register_blueprints(app):
    from .views import blueprint
    from flask_uploads import uploads_mod
    app.register_blueprint(blueprint)
    app.register_blueprint(uploads_mod)

src/challenge/views.py
from flask import Blueprint
from flask import request
from flask import redirect
from flask import url_for
from flask import abort
from flask import render_template
from .tasks import chunk_video_into_frames
from .extensions import video_storage
from .documents import Task


blueprint = Blueprint("views", __name__)


@blueprint.route("/task/<task_id>", methods=["GET"])
def task_details(task_id):
    counter = 10
    
    try:
        frames_count = int(request.args.get("frames_count", counter))
    except ValueError:
        frames_count = counter
    
    task = Task.objects(id=task_id).first()
    frames = task.data[:frames_count]
    
    if not task:
        abort(404)
    
    return render_template(
        "task-details.html", 
        task=task, 
        frames=frames,
        frames_count=frames_count,
        counter=counter
    )


@blueprint.route("/", methods=["GET"])
@blueprint.route("/tasks", methods=["GET"])
def tasks():
    tasks = Task.objects.all()
    return render_template("tasks-list.html", tasks=tasks)


@blueprint.route("/create-task", methods=["POST"])
def create_task():
    filename = video_storage.save(request.files['file'])
    task = Task(
        video_file=filename,
        with_objects_visualization=request.values.get("with_visualization", False)
    ).save()
    chunk_video_into_frames.send(str(task.id))
    return redirect(url_for('views.tasks'))

src/challenge/templates/base.html
<html>
    <head>
        <link 
            rel="stylesheet" 
            href="{{ url_for('static', filename='style.css') }}">

        <!-- CSS -->
        <link
            rel="stylesheet"
            href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" 
            integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" 
            crossorigin="anonymous">
        <!-- jQuery and JS bundle w/ Popper.js -->
        <script 
            src="https://code.jquery.com/jquery-3.5.1.slim.min.js" 
            integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" 
            crossorigin="anonymous"></script>
        <script 
            src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" 
            integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" 
            crossorigin="anonymous"></script>
    </head>
    <body>
        <div id="main-grid">
            <div id="header">
                <nav class="navbar navbar-light bg-light">
                    <div class="container-fluid">
                        <a class="navbar-brand" href="{{ url_for('views.tasks') }}"><h4>Object detector</h4></a>
                    </div>
                </nav>
            </div>
            <div id="content">
                {% block content %}
                {% endblock %}
            </div>
        </div>
    </body>
</html>

src/challenge/templates/task-details.html
{% extends "base.html" %}

{% block content %}

    <div class="d-flex flex-column align-items-start p-2 m-2">
        <h3>Task-{{ task.id }}</h3>
        <span>
            <b>Video file name:</b> 
            <a href="{{ url_for('_uploads.uploaded_file', setname='video', filename=task.video_file) }}">{{ task.video_file }}</a>
        </span>
        <span>
            <b>Frames count:</b> 
            {{ task.frames_count }}
        </span>
        <span>
            <b>Successfully processed frames:</b>
            <span class="text-success">{{ task.successful_frames | length }}</span>
        </span>
        <span>
            <b>Processeded with error frames:</b>
            <span class="text-danger">{{ task.failed_frames | length }}</span>
        </span>
        <span>
            <b>Created at:</b> 
            {{ task.created_at }}
        </span>
    </div>
    
    <hr>
    
    <h3>Frames:</h3>
    
    <div class="d-flex flex-column p-2">
        
        {% for record in frames %}
        
        <div class="d-flex flex-row p-3 bg-light">
            <img src="{{ url_for('_uploads.uploaded_file', setname='frames', filename=record.filename) }}" height="240" width="360">
            <div class="d-flex flex-column p-2">
                <ul>
                    {% for object_name, probability in record.data.items() %}
                    <li><b>{{ object_name }}</b>: {{ probability }}</li>
                    {% else %}
                    <span>Do not know(</span>
                    {% endfor %}
                </ul>
            </div>
        </div>
        
        {% else %}
        <span>Empty</span>
        {% endfor %}

        {% if frames %}
            <a href="{{ url_for('views.task_details', task_id=task.id, frames_count=frames_count+counter) }}" class="btn btn-primary">Show more</a>
        {% endif %}
    
    </div>

{% endblock %}

src/challenge/templates/tasks-list.html
{% extends "base.html" %}

{% block content %}
    
    <div class="d-flex flex-row align-items-center p-2 mb-2">
        <form 
            style="max-width: 400px;"
            method="POST" 
            enctype="multipart/form-data" 
            action="{{ url_for('views.create_task') }}">
            
            <div class="mb-3">
                <label for="file-input" class="form-label">Please select file</label>
                <input id="file-input" class="form-control" type="file" name="file" accept="video/mp4"/>
            </div>
            
            <div class="form-check mb-3">
                <input id="check-input" class="form-check-input" type="checkbox" value="" name="with_visualization">
                <label class="form-check-label" for="check-input">
                    With objects visualization ? <br>
                    (will take much longer time and is more CPU expensive)
                </label>
            </div>
            
            <button class="btn btn-primary" type="submit">Send</button>
        </form>
    </div>
    
    <hr>
    <h3>Task list:</h3>
    <div class="d-flex flex-column p-2">
        <p>
            After task creation the application will need some time to preccess a video.
            Therefore to see the current state of tasks - reload page.
        </p>
        {% for task in tasks %}
            <div class="d-flex flex-row p-3 bg-light">
                <div class="d-flex flex-column">
                    <a href="{{ url_for('views.task_details', task_id=task.id) }}">
                        <h3>Task-{{ task.id }}</h3>
                    </a>
                    <span>
                        <b>Video file name:</b>
                        <a href="{{ url_for('_uploads.uploaded_file', setname='video', filename=task.video_file) }}">{{ task.video_file }}</a>
                    </span>
                    <span>
                        <b>Frames count:</b> 
                        {{ task.frames_count }}
                    </span>
                    <span>
                        <b>Successfully processed frames:</b> 
                        <span class="text-success">{{ task.successful_frames | length }}</span>
                    </span>
                    <span>
                        <b>Processeded with error frames:</b>
                        <span class="text-danger">{{ task.failed_frames | length }}</span>
                    </span>
                    <span>
                        <b>Created at:</b> 
                        {{ task.created_at }}
                    </span>
                </div>
            </div>
        {% else %}
            <span>Empty</span>
        {% endfor %}
    </div>
{% endblock %}